<?php




require_once GREEN_ZONE_DIR . 'Utils/StringUtils.php';



class Angle
{
  public function __construct( Angle $s_angle = null )
  {
    if( $s_angle != null )
      $this->radians = $s_angle->ToRadians();
    else
      $this->radians = 0.0;
  }

  public function ToRadians() { return $this->radians; }
  public function FromRadians( $s_radians ) { $this->radians = $s_radians; }
  
  public function ToDegrees() { return ($this->radians / M_PI * 180.0); }
  public function FromDegrees( $s_degrees ) { $this->radians = $s_degrees / 180.0 * M_PI; }
  
  public function FromHMS( $s_hours, $s_mins, $s_secs )
  {
    $this->FromDegrees( $s_hours * 15.0 + $s_mins * 0.25 + $s_secs * 0.25 / 60.0 );
//     $this->radians = ((($s_hours * 15.0) + ($s_mins * 0.25) + ($s_sec * (0.25 / 60.0))) / 180.0) * M_PI;
  }
  public function ToHMS( &$hours, &$mins, &$secs )
  {
    $degrees = $this->ToDegrees();
    $hours = floor( ($degrees * 24.0) / 360.0);
    $hours_remainder = (( $degrees * 24.0) / 360.0 ) - $hours;
    $mins = floor( $hours_remainder * 60.0 );
    $mins_remainder = ($hours_remainder * 60.0) - $mins;
    $secs = $mins_remainder * 60;
  }

  public function FromHMSString( $s_hms )
  {
    $hours = strword( $s_hms, 0, ':' );
    $mins = strword( $s_hms, 1, ':' );
    $secs = strword( $s_hms, 2, ':' );

    $this->FromHMS( $hours, $mins, $secs );
  }
  
  public function ToHMSString()
  {
    $hours = 0;
    $mins = 0;
    $secs = 0;
    $this->ToHMS( $hours, $mins, $secs );
    
    return sprintf("%02d:%02d:%02d", $hours, $mins, $secs );
  }
  
  public function FromDMS( $s_degrees, $s_mins, $s_secs )
  {
    $degrees = $s_degrees;
    $degrees += $s_mins / 60.0;
    $degrees += $s_secs / 3600.0;
    $this->FromDegrees( $degrees );
  }
  
  public function FromDMSString( $dms_string )
  {
    $degrees = strword( $dms_string, 0, ':' );
    $mins = strword( $dms_string, 1, ':' );
    $secs = strword( $dms_string, 2, ':' );
    $this->FromDMS( $degrees, $mins, $secs );
  }
  
  public function ToDMS( &$degrees, &$mins, &$secs )
  {
    $degrees = $this->ToDegrees();
    $remainder = $degrees - floor($degrees);
    $mins = floor( $remainder * 60.0 );
    $remainder = ($remainder * 60.0) - $mins;
    $secs = $remainder * 60.0;
    $degrees = floor($degrees);
  }
  public function ToDMSString()
  {
    $degrees;
    $mins;
    $secs;
    $this->ToDMS( $degrees, $mins, $secs );

    return sprintf("%02d:%02d:%06.3f", $degrees, $mins, $secs );
  }
  
  private $radians;

};

?>