<?php



class Band
{
  // PUBLIC

  public function __construct( $s_name = '', $s_description = '', $s_lower_bound = '', $s_upper_bound = '')
  {
    $this->SetName($s_name);
    $this->SetDescription($s_description);
    $this->SetLowerBound($s_lower_bound);
    $this->SetUpperBound($s_upper_bound);

    if( !Band::$static_setup )
      Band::SetupStaticData();
  }

  public function GetName() { return $this->name; }
  public function SetName( $s_name ) { $this->name = $s_name; }

  public function GetDescription() { return $this->description; }
  public function SetDescription( $s_description ) { $this->description = $s_description; }

  public function GetLowerBound() { return $this->lower_bound; }
  public function SetLowerBound( $s_lower_bound ) { $this->lower_bound = $s_lower_bound; }

  public function GetUpperBound() { return $this->upper_bound; }
  public function SetUpperBound( $s_upper_bound ) { $this->upper_bound = $s_upper_bound; }

  // PRIVATE

  private $name;
  private $description;
  private $lower_bound;
  private $upper_bound;

  // STATIC

  private static $static_setup = false;
  public static $valid_bands = Array();

  public static function SetupStaticData()
  {
    Band::$static_setup = true;

    Band::$valid_bands[] = new Band( '70cm', '(~0.44 GHz)', 0.0, 500.0 );
    Band::$valid_bands[] = new Band( '50cm', '(~0.66 GHz)', 600.0, 700.0 );
    Band::$valid_bands[] = new Band( '20/18cm', '(1.2-1.8 GHz)', 1199.99, 1800.01 );
    Band::$valid_bands[] = new Band( '13cm', '(2.0-2.5 GHz)', 1999.99, 2500.01 );
    Band::$valid_bands[] = new Band( '10cm', '(2.6-3.6 GHz)', 2599.99, 3600.01 );
    Band::$valid_bands[] = new Band( '6cm', '(4.5-5.1 GHz)', 4499.99, 5100.01 );
    Band::$valid_bands[] = new Band( '5cm', '(5.9-6.8 GHz)', 5899.99, 6800.01 );
    Band::$valid_bands[] = new Band( '3cm', '(8.1-8.6 GHz)', 8099.99, 8600.01);
    Band::$valid_bands[] = new Band( '1.3cm', '(21.-24. GHZ)', 20999.99, 24000.01 );
  }
};

?>