<?php



require_once 'config.php';
require_once GREEN_ZONE_DIR . 'Utils/StringUtils.php';
require_once GREEN_ZONE_DIR . 'Utils/GZ_Exception.php';



class Date
{
  public function __construct( $s_dmy = null)
  {
    if( $s_dmy == null )
    {
      $this->day_of_month = null;
      $this->month_of_year = null;
      $this->year = null;
    }
    else
      $this->FromDMYString( $s_dmy );
  }
  
  public function IsUnset()
  { 
      if( $this->year != null ) 
	 return false; 
        return true; 
  }

  public function FromDMYString( $date_string )
  {
    // TODO add some checking to ensure that we have a properly formed string
    // and throw an exception if we don't
        
    $separator = '';
    if( strpos( $date_string, '/' ) !== false )
      $separator = '/';
    else if( strpos( $date_string, '-' ) !== false )
      $separator = '-';
    else
      throw( new GZ_Exception( 'Date::FromDMYString unknown separator string' ) );

    $this->SetDayOfMonth( strword( $date_string, 0, $separator ) );
    $this->SetMonthOfYear( strword( $date_string, 1, $separator ) );
    $this->SetYear( strword( $date_string, 2, $separator ) );
  }
  public function FromYMDString( $date_string )
  {
    // TODO add some checking to ensure that we have a properly formed string
    // and throw an exception if we don't
        
        $separator = '';
    if( strpos( $date_string, '/' ) !== false )
      $separator = '/';
    else if( strpos( $date_string, '-' ) !== false )
      $separator = '-';
    else
      throw( new GZ_Exception( 'Date::FromDMYString unknown separator string' ) );

    $this->SetDayOfMonth( strword( $date_string, 2, $separator ) );
    $this->SetMonthOfYear( strword( $date_string, 1, $separator ) );
    $this->SetYear( strword( $date_string, 0, $separator ) );
  }

  public function ToDMYString( $separator = '/' ) 
  {
    return $this->GetDayOfMonth() . $separator . $this->GetMonthOfYear() . $separator . $this->GetYear();
  }
  public function ToDMYString2( $separator = '/') 
  {
    return $this->GetDayOfMonth() . $separator . $this->GetMonthOfYearTxt() . $separator . $this->GetYear();
  }
  public function ToYMDStringDashed( $separator = '/' )
  {
    return $this->GetYear() . $separator . sprintf( '%02d', $this->GetMonthOfYear()) . $separator . sprintf('%02d',$this->GetDayOfMonth());
  }

  public function GetDayOfMonth() { return $this->day_of_month; }
  public function SetDayOfMonth( $s_day_of_month ) { $this->day_of_month = $s_day_of_month; }

  public function GetMonthOfYear() { return $this->month_of_year; }
  public function GetMonthOfYearTxt() { return Date::$months_in_year[intval($this->month_of_year)-1]; }
  public function SetMonthOfYear( $s_month_of_year )
  {
    if( is_numeric( $s_month_of_year ) )
      $this->month_of_year = $s_month_of_year;
    else
    {
      for( $ind = 0; $ind < count( Date::$months_in_year ); $ind ++ )
	if( Date::$months_in_year[$ind] == $s_month_of_year )
	  $this->month_of_year = $ind + 1;
    }
  }

  public function GetYear() { return $this->year; }
  public function SetYear( $s_year ) { $this->year = $s_year; }

  private $day_of_month;
  private $month_of_year;
  private $year;
  public static $arrays_setup = false;
  public static $days_in_month = Array( 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30 );
  public static $months_in_year = Array( 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' );
};





?>