<?php



/**
 * This simple class represents a path/filename pair. Not a very usefull class
 * but it does ensure both components are initialized to '' and we can get
 * either component on its own or both together.
 **/

class File
{
  // PUBLIC

    public function __construct( $s_path = '', $s_file = '' )
    {
      $this->path = $s_path;
      $this->filename = $s_file;
    }

    public function SetFilename( $s_filename ) { $this->filename = $s_filename; }
    public function SetPath( $s_path ) { $this->path = $s_path; }

    public function GetFilename() { return $this->filename; }
    public function GetPath() { return $this->path; }

    public function GetFullPath() { return "$this->path/$this->filename"; }
    public function SetFullPath( $s_full_path )
    {
      $this->path = substr( $s_full_path, 0, strrpos( $s_full_path, '/' ) );
      $this->filename = substr( $s_full_path, strrpos( $s_full_path, '/' ) + 1 );
    }

    public function IsDir() { return is_dir( $this->GetFullPath() ); }
    public function IsFile() { return is_file( $this->GetFullPath() ); }
    public function IsLink() { return is_link( $this->GetFullPath() ); }

    public function Exists() { return file_exists( $this->GetFullPath() ); }

    public function Create() { touch( $this->GetFullPath() ); }

    public function Remove() { unlink( $this->GetFullPath() ); }
    
    public function GetFileSize() { return filesize( $this->GetFullPath() ); }

  // PRIVATE

    private $filename;
    private $path;
};




?>