<?php



require_once 'Classes/General/File.php';



/**
 * This class is a tar file builder. Though the actual work of
 * building the tar file is done by execing tar. We use this
 * algorithm by giving it a data directory to compress the files
 * from, the names of all the files under that path we want to
 * add to the tar file, and the name and path to the tar file
 * we want to create.
 **/
class TarBuilder
{
  // PUBLIC

    public function __construct()
    {
      $this->tar_file = new File();
      $this->filenames = Array();
      $this->src_dir = '';
    }

    public function SetSrcDir( $s_src_dir ) { $this->src_dir = $s_src_dir; }
    public function AddFile( $new_file ) { $this->filenames[] = $new_file; }
    public function SetTarFile( File $s_tar_file ) { $this->tar_file = $s_tar_file; }

    public function GetTarFile() { return $this->tar_file; }

    //! Call exec to run tar and create our tarfile.
    public function Execute()
    {
      $web_dir = getcwd();
      chdir( $this->src_dir );

      $command = 'tar --dereference -cf ' . $this->tar_file->GetFullPath() . ' ';

      foreach( $this->filenames as $next_filename )
	$command .= $next_filename . ' ';

      $ret_val = '';
      $output_array = Array();
      $last_line = exec( $command, $output_array, $ret_val );

      // TODO throw an exception if the exec failed in some way
      // TODO throw an exception if no tar file was created.

      chdir( $web_dir );
    }

  // PRIVATE

    private $tar_file;
    private $src_dir;
    private $filenames;
};


?>