<?php

/**
 * Written by David Smith
 * nopeer@gmail.com
 *
 * For ATNF CSIRO
 *
 * This class represents the user data we wish to store in _SESSION.
 * This includes;
 * - The users email address
 * - The method of authenticate used 'anonymous' or 'opal'
 */

class UserData
{
  // PUBLIC

  public function __construct()
  {
    $this->auth_type = '';
    $this->email = '';
    $this->RestoreFromSession();
  }

  public function __destruct()
  {
    $this->SaveToSession();
  }

  public function SetAuthType( $s_auth_type ) { $this->auth_type = $s_auth_type; }
  public function GetAuthType() { return $this->auth_type; }

  public function SetEmail( $s_email ) { $this->email = $s_email; }
  public function GetEmail() { return $this->email; }

  public function RemoveFromSession()
  {
    global $_SESSION;

    unset( $_SESSION['userdata_email'] );
    unset( $_SESSION['userdata_auth_type'] );

    $this->email = '';
    $this->auth_type = '';
  }

  // PRIVATE

  private $auth_type;
  private $email;

  private function SaveToSession()
  {
    global $_SESSION;

    if( $this->auth_type != '' )
    {
      $_SESSION['userdata_auth_type'] = $this->auth_type;
      $_SESSION['userdata_email'] = $this->email;
    }
  }

  private function RestoreFromSession()
  {
    global $_SESSION;

    if( isset( $_SESSION['userdata_auth_type'] ) )
      $this->auth_type = $_SESSION['userdata_auth_type'];

    if( isset( $_SESSION['userdata_email'] ) )
      $this->email = $_SESSION['userdata_email'];
  }
};

?>