<?php



require_once 'Classes/Astro/SkyCoord.php';



/**
 * @class Calibration
 *
 * This class represents a calibration, it contains an array whith the contents of
 * an entry in the cals table of the database that corresponds to this calibration.
 **/
class Calibration
{
  public $is_calibration = true;
  
  
  
  // PUBLIC
      
  public function __construct()
  {
    $this->coordinates = new SkyCoord();
    $this->file_id = null;
    $this->mjd = null;
  }
  
  /**
   * This function extracts the parameters for this object from the 
   * database record given.
   **/

  public function FromRecord( $record )
  {
    $this->coordinates = new SkyCoord();
    
    $ra_angle = new Angle();
    $ra_angle->FromDegrees( $record['rajd'] );
    
    $dec_angle = new Angle();
    $dec_angle->FromDegrees( $record['decjd'] );
    
    $new_coords = new SkyCoord();
    $new_coords->SetRA( $ra_angle );
    $new_coords->SetDEC( $dec_angle );
    
    $this->SetCoordinates( $new_coords );
    
    $this->mjd = new MJD();
    $this->mjd->FromString( $record['MJD'] );
  }
  
  public function SetFileID( $s_file_id ) { $this->file_id = $s_file_id; }
  public function GetFileID() { return $this->file_id; }
  
  public function SetCoordinates( $s_coordinates ) { $this->coordinates = $s_coordinates; }
  public function GetCoordinates() { return $this>coordinates; }
  
  public function GetRA() { if( $this->coordinates == null ) return ull; return $this->GetCoordinates()->GetRA(); }
  public function GetDEC() { return $this->GetCoordiantes()->GetDEC(); }
  
  public function SetMJD( $s_mjd ) { $this->mjd = $s_mjd; }
  public function GetMJD() { return $this->mjd; }
  
  

  
  // PRIVATE
      
  private $file_id;
  private $coordinates;
  private $mjd;
};





?>