<?php



require_once GREEN_ZONE_DIR . 'Utils/StringUtils.php';
require_once 'Classes/Astro/SkyCoord.php';



class PulsarCatalog
{
  // PUBLIC
      
  public function __construct()
  {
    
  }
  
  //! Return a SkyCoord for the pulsar given
  public function GetCoordsForPulsar( $src_name )
  {
    $psrcat_cmd = '/pulsar/psr/linux/bin/psrcat -nohead -nonumber -o short -c "RAJD DECJD" ' . $src_name;

    $all_lines = Array();
    $ret_val = '';
    $last_line = exec( $psrcat_cmd, $all_lines, $ret_val );
    
    // TODO throw exceptions if exec failed

    $last_line = trim( $last_line );
    
    $ra_degrees = strword( $last_line, 0 );
    $last_line = AdvanceStringTo( $last_line, $ra_degrees );
    $dec_degrees = trim( $last_line );
    
    $ra_angle = new Angle();
    $ra_angle->FromDegrees( $ra_degrees );
    $dec_angle = new Angle();
    $dec_angle->FromDegrees( $dec_degrees );
  
    $coords = new SkyCoord();
    $coords->SetRA( $ra_angle );
    $coords->SetDEC( $dec_angle );
    
    return $coords;
  }
  
  // PRIVATE
      
};

?>