<?php



require_once 'Classes/Astro/MJD.php';



/**
 * This class represents the algorithm for performing a calibration query
 * Usage:
 * $searcher = new CalQuery();
 * $searcher->SetStartTime( $start_mjd );
 * $searcher->SetEndTiem( $end_mjd );
 * $searcher->Execute();
 * $calibrations = $searcher->GetCalibrations();
 **/

class CalQuery
{
  // PUBLIC
  
  public function __construct()
  {
    $this->start_mjd = new MJD();
    $this->end_mjd = new MJD();
    $this->results = Array();
  }
  
  public function SetStartTime( MJD $s_start_time ) { $this->start_time = $s_start_time; }
  public function SetEndTime( MJD $s_end_time ) { $this->end_time = $s_end_time; }
  
  public function Execute( MysqlDB $db )
  {
    $select_sql = ' SELECT * FROM cals WHERE MJD < ' . $this->end_time->ToString();
    $select_sql .= ' AND MJD > ' . $this->start_time->ToString();
    
                  //echo 'executing cal query ' . $select_sql . ' <br> ';
                  
    $db->DoQuery( $select_sql );
    
    if( $db->FetchNumRows() > 0 )
      $this->ExtractResults( $db->GetLastResult() );
  }
  
  public function GetCalibrations() { return $this->results; }
  
  // PRIVATE
  
  private $start_mjd;
  private $end_mjd;
  private $results;
  
  private function ExtractResults( $array_data )
  {
    foreach( $array_data as $next_record )
    {
      $new_calibration = new Calibration();
      $new_calibration->FromRecord( $next_record );
      $this->results[] = $new_calibration;
    }
  }
};





?>