<?php




require_once 'Classes/Astro/MJD.php';



class DateRangeQuery
{
  public function __construct()
  {
    $this->date_range = new DateRange();
  }

  public function Execute( $db )
  {
    $select_sql = ' SELECT min(MJD) as min, max(MJD) as max ' .
	          ' FROM observations ';
    
    $db->DoQuery( $select_sql );
    
    $db->EnsureNumRows( 'equals', 1 );
    
    $row = $db->GetLastResult();
    $min_mjd = new MJD( $row[0]['min'] );
    $max_mjd = new MJD( $row[0]['max'] );
    
    $range = new DateRange();
    $range->SetFromDate( $min_mjd->ToDate() );
    $range->SetToDate( $max_mjd->ToDate() );
    
    return $range;
  }

  public function GetDateRange()
  {
    return $date_range;
  }

  private $date_range;
};





?>