<?php



require_once 'config.php';
require_once GREEN_ZONE_DIR . 'Tests/BaseTest.php';
require_once 'Classes/General/Date.php';



class TestDate extends BaseTest
{
  function TestIt()
  {
    $day = '1';
    $month = '2';
    $year = '2008';
  
    $d1 = new Date();
    $d1->SetDayOfMonth( $day );
  
    $this->PerformTest( 'Testing day getter/setter',
		( $day == $d1->GetDayOfMonth() ),
		'Failed to retrieve the day we set' );
  
    $d1->SetMonthOfYear( $month );
    $this->PerformTest( 'Testing month getter/setter',
		( $month == $d1->GetMonthOfYear() ),
		'Failed to retrieve the month we set' );
  
    $d1->SetYear( $year );
    $this->PerformTest( 'Testing year getter/setter',
		( $year == $d1->GetYear() ),
		'Failed to retrieve the year we set' );
  
    $d1->FromDMYString( '12/12/1212' );
    $this->PerformTest( 'Testing DMY getter/setter',
		( $d1->ToDMYString() == '12/12/1212' ),
		'The date set and retrieved do not match' . $d1->ToDMYString() );
    
    $this->PerformTest( 'Testing DMY getter 2 (month is string)',
                        ( $d1->ToDMYString2() == '12/Dec/1212' ),
                          'Failed to retrieve date with text month ' . $d1->ToDMYString2() );
  }
}


?>