<?php




require_once 'config.php';
require_once GREEN_ZONE_DIR . 'Tests/BaseTest.php';
require_once 'Classes/General/Dir.php';
require_once 'Classes/General/File.php';



class TestDir extends BaseTest
{
  public function TestIt()
  {
    // get a temporary filename
    // test that there is no dir with that name
    // create a directory using that tmpfile name
    // test that the new directory exists as a directory
    // create a test file in the directory
    // test that the test file was created correctly
    // get the list of files in the directory
    // test that the list simply contains the test file
    // delete the test file
    // remove the directory
    // test that the directory no longer exists
  
    $tmp_file = new File();
    $tmp_file->SetFullPath( tempnam('','') );
    $tmp_file->Remove();
    
    $dir = new Dir();
    $dir->SetPath( $tmp_file->GetFullPath() );
    
    $this->PerformTest( 'Testing temp file doesnt exist',
		( !$tmp_file->Exists() ),
		'The file created by tempnam still exists' );
    
    $this->PerformTest( 'Testing temp dir does not exist',
		( !$dir->IsDir() ),
		'The test directory exists for some reason ' . $dir->GetPath() );
    
    $dir->Create();
    
    $this->PerformTest( 'Test that we created the directory successfully',
		( $dir->IsDir() ),
		'Failed to create the directory ' . $dir->GetPath() );
    
    $test_file = new File( $dir->GetPath(), 'testing' );
    $test_file->Create();
    $this->PerformTest( 'Testing we can create a file in the new directory',
		( $test_file->Exists() ),
		'Failed to create file called testing in directory' . $dir->GetPath() );
    
    $all_files = $dir->ListFiles();
    $this->PerformTest( 'Testing we have the correct number of files from the directory',
		( count($all_files) == 3 ),
		'Wrong number of files listed in directory ' . count($all_files) );
    
    $this->PerformTest( 'Testing the file we want is listed correctly',
		( $all_files[1] == 'testing' ),
		'The file "testing" is not there' );
    
    $test_file->Remove();
    $this->PerformTest( 'testing we removed the test file successfully',
		( !$test_file->Exists() ),
		'Failed to remove the test file from out test directory' );
    
    $dir->Remove();
    
    $this->PerformTest( 'Test that we can remove the directoroy',
		( !$dir->IsDir() ),
		'Failed to remove the directory ' . $dir->GetPath() );
  }
};


?>