<?php



/**
 * Written by David Smith
 * nopeer@gmail.com
 *
 * For ATNF CSIRO
 *
 * This form presents a login dialog.
 */



require_once GREEN_ZONE_DIR . 'Forms/GZ_BaseForm.php';
require_once 'Classes/General/UserData.php';




class LoginForm extends GZ_BaseForm
{
  var $failure;
  var $user_data;

  function __construct( $set_gz )
  {
    parent::__construct( $set_gz );

    $this->failure = false;

    $this->user_data = new UserData();
  }


  function LoggedIn()
  {
    $logged_in = false;
    
    if( $this->user_data != '' )
    {
      $method = $this->user_data->GetAuthType();
      if( $method == 'anonymous' || $method == 'opal' )
	$logged_in = true;
    }
    
    return $logged_in;
  }


  function Login()
  {
    global $_SESSION;

    if( $this->GetPostString('authenticateType') == 'anon' )
    {
      if( !is_string( $this->GetPostString('email') ) ||
          strlen( $this->GetPostString('email') ) < 4 ||
          strpos( $this->GetPostString('email'), '@' ) === false ||
          strpos( $this->GetPostString('email'), '.' ) === false )
        throw new GZ_Exception( 'Enter a valid email address', 'LoginForm::Login' );

      if( $this->user_data == '' )
        $this->user_data = new UserData();
    
      $this->user_data->SetEmail( $this->GetPostString( 'email' ) );
      $this->user_data->SetAuthType( 'anonymous' );
    }

    // TODO add opal login code here
  }



  function Logout()
  {
    global $_SESSION;

    if( $this->user_data != '' )
      $this->user_data->RemoveFromSession();
    foreach( $_SESSION as $name => $value )
      unset( $_SESSION[$name] );
  }



  function Display()
  {
    global $_SERVER;

    $smarty = $this->gz->CreateSmarty();

    $logged_in = $this->LoggedIn();
    $proprietary_period = 12;
    $self = $_SERVER['PHP_SELF'];

    $this->gz->smarty_assign( $smarty, 'logged_in', $logged_in );
    $this->gz->smarty_assign( $smarty, 'proprietary_period', $propietary_period );
    $this->gz->smarty_assign( $smarty, 'self', $self );

    $smarty->Display( 'LoginForm.tpl' );
  }


  function ProcessActions()
  {
    if( $this->ActionIs( 'Login' ) )
      $this->Login();
    else if( $this->ActionIs( 'Logout' ) )
      $this->Logout();

    if( $this->LoggedIn() )
      return 'QueryForm';
    else
      return '';
  }
};






?>