<?php



require_once GREEN_ZONE_DIR . 'Forms/GZ_BaseForm.php';
require_once GREEN_ZONE_DIR . 'Forms/GZ_Pager.php';



class GZ_Paginator extends GZ_BaseForm
{
  // PUBLIC
      
  public function __construct( $s_gz, $s_html_id )
  {
    global $_SESSION;
    
    parent::__construct( $s_gz );
    
    $this->pagers = Array();
    $this->total_pages = 1;
    $this->current_page = 1;
    $this->html_id = $s_html_id;
  }
  
  public function AddPager( $new_pager ) { $this->pagers[] = $new_pager; }
  
  public function Display()
  {
    echo '<font size=4>';
    // draw the paginator controls
    for( $ind = 1; $ind <= $this->total_pages; $ind ++ )
    {
      if( $ind == $this->current_page )
	echo " <b>$ind</b>";
      else
	echo " <a href=?page=$ind>$ind</a>";
    }
    echo '<br><br>';
    echo '</font>';
  }
  
  public function CheckCurrentPage()
  {
    if( $this->current_page > $this->total_pages )
      $this->current_page = $this->total_pages;
    if( $this->current_page < 1 )
      $this->current_page = 1;
  }
  
  public function DeterminePageRange()
  {
    // check all the pagers to determine the maximum page range

    $this->total_pages = 0;
    foreach( $this->pagers as $next_pager )
    {
      $next_num_pages = $next_pager->GetNumPages();
      if( $next_num_pages > $this->total_pages )
	$this->total_pages = $next_num_pages;
    }
  }
  
  public function Paginate()
  {
    $this->DeterminePageRange();
    
    $this->CheckCurrentPage();
    
    foreach( $this->pagers as $next_pager )
      $next_pager->SetPage( $this->current_page );
  }
  
  public function SetPage( $s_page )
  {
    global $_SESSION;
    echo 'setting page to ' . $s_page . ' <br>';
    $this->current_page = $s_page;
    
    $this->CheckCurrentPage();
    
    $_SESSION[ $this->html_id . 'CurrentPage' ] = $this->current_page;
  }
  
  public function ReadForm()
  {
    if( isset( $_SESSION[ $this->html_id . 'CurrentPage' ] ) )
      $this->current_page = $_SESSION[ $this->html_id . 'CurrentPage' ];

    if( isset( $this->gz->_GET['page'] ) )
      $this->current_page = $this->gz->_GET['page'];
  }
  
  public function ProcessActions()
  {
    $this->Paginate();
    
    return '';
  }
  
  // PRIVATE
  
  private $pagers;
  private $total_pages;
  private $current_page;
};

?>