<?php




define( 'INVALID_PARAM', 100 );
define( 'FAILED_CALL', 101 );
define( 'QUERY_FAILED', 102 );
define( 'NO_ROWS', 103 );
define( 'OUT_OF_RANGE', 104 );
define( 'DISCONNECTED', 105 );





/**
 * This class extends phps basic exception class to include
 * details of the method that called the exception and a code
 * for identifying the type of exception.
 * code that is unaware of the extra field will operate as though it
 * were a normal exception.
 **/

class GZ_Exception extends Exception
{
  // PUBLIC
      
  public function __construct( $s_message = null, $s_method = null, $s_code = null)
  {
    parent::__construct();
    
    $this->message = $s_message;
    $this->method = $s_method;
    $this->code = $s_code;
  }

  
  public function getMethod()
  {
    return $this->method;
  }
  
  // PRIVATE
      
  private $method;
};
?>